
/**
 * A lsit of Strings.
 * 
 
 * @version 3
 */

public interface StringList
{

/**
 * tell whether the list is empty.
 * @return a boolean
 * @since version 2
 */
public boolean isEmpty ();

/**
 * how many elements in the list?
 * 
 * @return an int, how many elements
 * @since version 3
 */
public int size();

/**
 * is this list the same as another list?
 * 
 * @return a boolean: do the lists contain the same strings in the same order?
 * @since version 4
 */
public boolean equals (Object other);

/**
 * append one list to the end of another.
 * 
 * @param other   the list to tack onto the end of this one.
 * @return a new list with all the elements of this, followed by all the
 * elements of other.
 * @since version 5
 */
public StringList append (StringList other);

    /**
     * reverse a list.
     * @return a new list with the same elements in the opposite order.
     */
    public StringList reverse ();
    

}
